; Inno Setup Script
; (C) Czo 1999, 2000 <Olivier.Sirol@lip6.fr>
;
; Inno Setup is a free solution for creating basic installations on Windows
; See : http://www.jordanr.dhs.org/isinfo.htm 
;
; limitations in IS 1.09 :
; dir 47 chars max, file 63 char max seems to have diseapeared
; find alliance \! -type d | gawk '{ t=length($0) ; if (t> tmax) { tmax=t ; print tmax}}'
; ( echo "[Dirs]" ;  find alliance -type d | gawk '{ gsub(/\//,"\\") ; printf("Name: \"{app}\\%s\"\n", $0) }' ; echo [Files]; find alliance \! -type d \! -type l | gawk '{ gsub(/\//,"\\") ; MDIR=$0; gsub(/\\[^\\]*$/,"",MDIR); printf("Source: \"%s\"; Destdir: \"{app}\\%s\"\n", $0, MDIR) }' ; find alliance -type l | gawk '{ gsub(/\//,"\\") ; MDIR=$0; gsub(/\\[^\\]*$/,"",MDIR); printf("Source: \"%s\"; Destdir: \"{app}\\%s\"; Attribs: system\n", $0, MDIR) }' ) > totol
;
; With Cygwin symlinks have System attrib set
; attrib /s | grep -v "^A   "


[Setup]
Bits=32
AppName=Alliance VLSI CAD 4.0.6
AppVerName=Alliance VLSI CAD 4.0.6
AppCopyright=Packaged by Czo, Feb 2000

OutputBaseFilename=alliance-4.0.6-cygwin
OutputDir=c:\tmp\output

DisableDirPage=0
DefaultDirName=c:\usr\local
DefaultGroupName=Alliance
AllowRootDirectory=1
MinVersion=4,3.51

InfoBeforeFile=alliance-readme-before.txt
InfoAfterFile=alliance-readme-after.txt
LicenseFile=COPYING-2.0

[Icons]
Name: "{group}\Alliance Console"; Filename: "%COMSPEC%"; Parameters: "/K {app}\alliance\share\etc\alc_env.bat"; WorkingDir: "c:\"; IconFilename: "{app}\alliance\share\etc\alliance.ico"; 
Name: "{group}\Alliance Home Page"; Filename: "{app}\alliance\share\etc\Alliance Home Page.url"

[Registry]
Root: HKCU; Subkey: "Software\UPMC\Alliance"; Flags: uninsdeletekeyifempty
Root: HKCU; Subkey: "Software\UPMC\Alliance\4.0.6"; Flags: uninsdeletekey
Root: HKLM; Subkey: "Software\UPMC\Alliance"; Flags: uninsdeletekeyifempty
Root: HKLM; Subkey: "Software\UPMC\Alliance\4.0.6"; Flags: uninsdeletekey
Root: HKLM; Subkey: "Software\UPMC\Alliance\4.0.6\Install"; ValueType: string; ValueName: "Path"; ValueData: "{app}"


[Dirs]
Name: "{app}\alliance"
Name: "{app}\alliance\archi"
Name: "{app}\alliance\archi\Cygwin"
Name: "{app}\alliance\archi\Cygwin\bin"
Name: "{app}\alliance\archi\Cygwin\include"
Name: "{app}\alliance\archi\Cygwin\lib"
Name: "{app}\alliance\share"
Name: "{app}\alliance\share\cells"
Name: "{app}\alliance\share\cells\amg"
Name: "{app}\alliance\share\cells\bsg"
Name: "{app}\alliance\share\cells\dplib"
Name: "{app}\alliance\share\cells\fplib"
Name: "{app}\alliance\share\cells\grog"
Name: "{app}\alliance\share\cells\padlib"
Name: "{app}\alliance\share\cells\rage"
Name: "{app}\alliance\share\cells\rfg"
Name: "{app}\alliance\share\cells\rsa"
Name: "{app}\alliance\share\cells\sc2sxlib"
Name: "{app}\alliance\share\cells\sclib"
Name: "{app}\alliance\share\cells\sxlib"
Name: "{app}\alliance\share\doc"
Name: "{app}\alliance\share\doc\overview"
Name: "{app}\alliance\share\etc"
Name: "{app}\alliance\share\etc\algue"
Name: "{app}\alliance\share\man"
Name: "{app}\alliance\share\man\man1"
Name: "{app}\alliance\share\man\man3"
Name: "{app}\alliance\share\man\man5"
Name: "{app}\alliance\share\tutorials"
Name: "{app}\alliance\share\tutorials\addaccu"
Name: "{app}\alliance\share\tutorials\addaccu\tex"
Name: "{app}\alliance\share\tutorials\amd2901"
Name: "{app}\alliance\share\tutorials\amd2901\tex"
Name: "{app}\alliance\share\tutorials\dlxm"
Name: "{app}\alliance\share\tutorials\dlxm\latex"
Name: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Name: "{app}\alliance\share\tutorials\fitpath"
Name: "{app}\alliance\share\tutorials\fitpath\tex"
[Files]
Source: "alliance\archi\Cygwin\bin\alcbanner.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\algue"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\ali"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\amg.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\asimut.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\b2f.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\bbr.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\bop.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\bsg.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\c4map.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\cygwin1.dll"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\dlx_asm.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\dpr.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\dreal.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\druc.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\flatbeh.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\flatlo.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\flatph.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\flatrds.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\fpgen"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\fpmap.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\genlib"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\genpat"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\genscan.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\genview.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\genview_cc1.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\genview_cpp"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\genview_gcc.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\glop.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\graal.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\grog.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\k2f.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\l2p.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\lvx.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\lynx.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\mips_asm.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\proof.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\rage.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\rfg.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\ring.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\rsa.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\s2r.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\scmap.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\scr.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\syf.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\vasy.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\x2y.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\xfsm.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\xpat.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\xsch.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\bin\xvpn.exe"; Destdir: "{app}\alliance\archi\Cygwin\bin"
Source: "alliance\archi\Cygwin\include\abe200.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\abl103.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\abt200.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\abv200.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\apr103.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\aut103.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\bdd104.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\beh110.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\bfl106.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\bhl110.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\btr103.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\but101.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\bvl113.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\cns211.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\elp105.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\fgn115.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\fks104.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\fpgen.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\fsm104.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\ftl104.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\fvh104.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\gam000.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\gbs201.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\gcp101.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\genlib.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\genpat.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\gfp115.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\gga301.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\ggr001.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\grf605.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\iac201.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\icn201.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\icu201.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\lax100.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\log201.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\mal603.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\map406.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\mbkgen.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\mcl413.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\mcp407.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\mgn328.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\mlo501.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\mlu501.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\mph410.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\mpu406.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\msl700.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\mut325.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\pat108.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\phl108.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\ppt108.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\rcf111.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\rcn200.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\rds209.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\rfm210.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\rgs112.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\rpr213.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\rps103.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\rtd101.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\rtl110.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\rtn101.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\rut208.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\rwi109.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\sch110.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\scl103.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\vbh104.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\vbl104.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\vex103.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\vpn105.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\vrd303.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\vtl105.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\include\xnf101.h"; Destdir: "{app}\alliance\archi\Cygwin\include"
Source: "alliance\archi\Cygwin\lib\libAbe200.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libAbl103.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libAbt200.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libAbv200.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libApr103.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libAut103.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libBdd104.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libBeh110.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libBfl106.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libBhl110.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libBtr103.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libBut101.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libBvl113.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libCns211.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libCst100.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libElp105.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libFgn115.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libFks104.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libFsm104.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libFtl104.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libFvh104.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libGam000.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libGbs201.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libGcp101.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libGfp115.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libGga301.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libGgr001.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libGrf605.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libIca201.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libIcc201.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libIcn201.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libIcu201.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libLax100.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\liblog201.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libMal603.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libMap406.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libMcl413.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libMcp407.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libMel407.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libMgl100.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libMgn328.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libMhl403.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libMlo501.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libMlu501.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libMmg402.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libMph410.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libMpu406.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libMsl700.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libMut325.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libMvl409.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libPat108.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libPgn103.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libPhl108.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libPpt108.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libRcf111.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libRcn200.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libRds209.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libRfm210.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libRgs112.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libRpr213.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libRps103.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libRtd101.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libRtl110.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libRtn101.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libRut208.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libRwi109.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libSch110.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libScl103.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libVbh104.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libVbl104.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libVex103.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libVpd105.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libVpn105.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libVrd303.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libVtl105.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libVvh105.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\archi\Cygwin\lib\libXnf101.a"; Destdir: "{app}\alliance\archi\Cygwin\lib"
Source: "alliance\CHANGES"; Destdir: "{app}\alliance"
Source: "alliance\COPYING-2.0"; Destdir: "{app}\alliance"
Source: "alliance\COPYING.LIB-2.0"; Destdir: "{app}\alliance"
Source: "alliance\FAQ"; Destdir: "{app}\alliance"
Source: "alliance\LICENCE"; Destdir: "{app}\alliance"
Source: "alliance\README"; Destdir: "{app}\alliance"
Source: "alliance\share\cells\amg\amalimiout_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimiout_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimiout_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimitop_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimitop_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimitop_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimi_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimi_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimi_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimpbot_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimpbot_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimpbot_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimpout_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimpout_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimpout_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimptop_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimptop_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimptop_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimp_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimp_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amalimp_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcl4lft_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcl4lft_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcl4lft_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcl4out_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcl4out_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcl4out_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcl4_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcl4_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcl4_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcoin_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcoin_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcoin_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaiinbot_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaiinbot_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaiinbot_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaiintop_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaiintop_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaiintop_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaiin_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaiin_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaiin_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaiouttop_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaiouttop_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaiouttop_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaiout_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaiout_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaiout_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaitop_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaitop_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaitop_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsai_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsai_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsai_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsapintop_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsapintop_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsapintop_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsapin_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsapin_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsapin_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsapouttop_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsapouttop_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsapouttop_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsapout_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsapout_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsapout_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaptop_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaptop_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsaptop_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsap_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsap_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amcsap_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amdncbot_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amdncbot_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amdncbot_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amdnctop1_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amdnctop1_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amdnctop1_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amdnctop2_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amdnctop2_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amdnctop2_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amdnc_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amdnc_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amdnc_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxi1bot_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxi1bot_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxi1bot_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxi1top_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxi1top_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxi1top_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxi1_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxi1_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxi1_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxibot_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxibot_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxibot_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxiinbot_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxiinbot_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxiinbot_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxiintop_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxiintop_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxiintop_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxiin_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxiin_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxiin_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxitop_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxitop_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxitop_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxi_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxi_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxi_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxp1top_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxp1top_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxp1top_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxp1_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxp1_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxp1_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxpintop_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxpintop_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxpintop_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxpin_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxpin_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxpin_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxptop_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxptop_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxptop_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxp_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxp_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\ammuxp_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutibot_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutibot_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutibot_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutitop1_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutitop1_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutitop1_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutitop2_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutitop2_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutitop2_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutitop_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutitop_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutitop_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amouti_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amouti_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amouti_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutpbot_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutpbot_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutpbot_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutptop1_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutptop1_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutptop1_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutptop2_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutptop2_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutptop2_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutptop_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutptop_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutptop_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutp_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutp_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amoutp_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregbot0_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregbot0_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregbot0_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregbot1_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregbot1_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregbot1_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregbotn_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregbotn_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregbotn_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregni1_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregni1_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregni1_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregni2_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregni2_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregni2_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregni_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregni_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregni_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregnp1_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregnp1_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregnp1_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregnp2_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregnp2_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregnp2_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregnp_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregnp_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregnp_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt0i1_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt0i1_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt0i1_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt0i_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt0i_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt0i_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt0p1_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt0p1_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt0p1_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt0p_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt0p_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt0p_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt1i1_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt1i1_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt1i1_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt1i_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt1i_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt1i_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt1p1_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt1p1_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt1p1_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt1p_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt1p_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregt1p_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtop01_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtop01_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtop01_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtop02_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtop02_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtop02_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtop10_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtop10_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtop10_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtop11_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtop11_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtop11_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtop12_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtop12_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtop12_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtop13_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtop13_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtop13_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtopn1_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtopn1_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtopn1_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtopn2_c.ap"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtopn2_c.cp"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\amregtopn2_c.hns"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\amg\CATAL"; Destdir: "{app}\alliance\share\cells\amg"
Source: "alliance\share\cells\bsg\bsalim_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsalim_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsalim_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdand16_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdand16_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdand16_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdand32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdand32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdand32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdand4_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdand4_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdand4_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdand64_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdand64_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdand64_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdand8_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdand8_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdand8_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandh16_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandh16_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandh16_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandh32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandh32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandh32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandh64_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandh64_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandh64_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandh8_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandh8_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandh8_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandhi16_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandhi16_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandhi16_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandhi32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandhi32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandhi32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandhi64_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandhi64_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandhi64_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandhi8_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandhi8_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandhi8_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandi4_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandi4_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandi4_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandi8_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandi8_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdandi8_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdbuf32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdbuf32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdbuf32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdbufi32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdbufi32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdbufi32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdept32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdept32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdept32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdepti32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdepti32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsdepti32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshalim_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshalim_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshalim_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshand16_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshand16_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshand16_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshand32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshand32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshand32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshand4_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshand4_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshand4_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshand64_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshand64_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshand64_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshand8_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshand8_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshand8_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshcmd32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshcmd32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshcmd32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshcmdi32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshcmdi32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshcmdi32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshept32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshept32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshept32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshlmx32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshlmx32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshlmx32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshlmxi32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshlmxi32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshlmxi32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshmat32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshmat32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshmat32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshmati32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshmati32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshmati32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshmatr32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshmatr32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshmatr32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshout32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshout32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshout32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshrmx32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshrmx32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshrmx32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshsel32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshsel32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshsel32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshseli32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshseli32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bshseli32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bslmuxi32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bslmuxi32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bslmuxi32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bslmuxm32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bslmuxm32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bslmuxm32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bslmuxt32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bslmuxt32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bslmuxt32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsmlef32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsmlef32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsmlef32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsmlefi32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsmlefi32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsmlefi32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsmmat32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsmmat32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsmmat32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsmmati32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsmmati32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsmmati32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsmrig32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsmrig32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsmrig32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsoout32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsoout32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsoout32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsoouti32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsoouti32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsoouti32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsrmux32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsrmux32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsrmux32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsrmuxi32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsrmuxi32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bsrmuxi32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bssnbli32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bssnbli32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bssnbli32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bssnblm32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bssnblm32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bssnblm32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bssnblt32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bssnblt32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bssnblt32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bssseli32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bssseli32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bssseli32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bssselm32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bssselm32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bssselm32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bssselt32_c.ap"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bssselt32_c.cp"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\bssselt32_c.sc"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\bsg\CATAL"; Destdir: "{app}\alliance\share\cells\bsg"
Source: "alliance\share\cells\dplib\a2p_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\a2p_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\a2p_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\a2_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\a2_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\a2_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\a3p_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\a3p_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\a3p_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\a3_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\a3_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\a3_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\a4p_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\a4p_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\a4p_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\a4_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\a4_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\a4_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\annup_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\annup_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\annup_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\b1_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\b1_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\b1_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\CATAL"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\cry_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\cry_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\cry_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\dplib.db"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ms2n_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ms2n_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ms2n_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ms2rx_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ms2rx_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ms2rx_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ms2sx_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ms2sx_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ms2sx_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ms2x_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ms2x_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ms2x_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ms2_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ms2_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ms2_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\msn_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\msn_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\msn_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\msrx_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\msrx_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\msrx_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\mssx_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\mssx_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\mssx_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\msx_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\msx_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\msx_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ms_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ms_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ms_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\mx2p_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\mx2p_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\mx2p_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\mx2_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\mx2_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\mx2_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\mx3_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\mx3_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\mx3_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\n1_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\n1_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\n1_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\na2p_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\na2p_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\na2p_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\na2_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\na2_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\na2_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\na3p_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\na3p_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\na3p_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\na3_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\na3_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\na3_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\na4_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\na4_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\na4_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\nao3_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\nao3_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\nao3_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\nao4_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\nao4_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\nao4_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ndrv_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ndrv_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ndrv_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\neou4_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\neou4_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\neou4_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\nmx2_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\nmx2_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\nmx2_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\no2_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\no2_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\no2_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\no3_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\no3_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\no3_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\noa3_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\noa3_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\noa3_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\noa4_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\noa4_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\noa4_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\nop2_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\nop2_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\nop2_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\nop3_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\nop3_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\nop3_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\noue4_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\noue4_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\noue4_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\np1_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\np1_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\np1_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\nxr2_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\nxr2_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\nxr2_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\o2_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\o2_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\o2_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\o3_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\o3_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\o3_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\one_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\one_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\one_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\op2_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\op2_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\op2_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\op3_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\op3_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\op3_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\p1_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\p1_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\p1_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\sum_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\sum_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\sum_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\tsn_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\tsn_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\tsn_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ts_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ts_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\ts_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\xr2_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\xr2_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\xr2_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\zero_dp.al"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\zero_dp.ap"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\dplib\zero_dp.vbe"; Destdir: "{app}\alliance\share\cells\dplib"
Source: "alliance\share\cells\fplib\a2p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a2p_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a2p_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a2p_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a2p_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a2p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a2_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a2_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a2_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a2_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a2_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a2_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a3p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a3p_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a3p_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a3p_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a3p_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a3p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a3_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a3_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a3_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a3_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a3_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\a3_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bna2x_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bna2x_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bna2x_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bna2x_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bna2x_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bna2x_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bno2x_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bno2x_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bno2x_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bno2x_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bno2x_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bno2x_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bnt1_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bnt1_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bnt1_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bnt1_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bnt1_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bnt1_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bnxr2x_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bnxr2x_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bnxr2x_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bnxr2x_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bnxr2x_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bnxr2x_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bt1_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bt1_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bt1_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bt1_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bt1_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\bt1_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\buff_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\buff_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\buff_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\buff_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\buff_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\buff_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\CATAL"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\drvp_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\drvp_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\drvp_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\drvp_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\drvp_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\drvp_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\drv_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\drv_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\drv_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\drv_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\drv_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\drv_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx2sb0_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx2sb0_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx2sb0_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx2sb0_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx2sb0_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx2sb0_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx2sc_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx2sc_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx2sc_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx2sc_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx2sc_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx2sc_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx3sb0_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx3sb0_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx3sb0_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx3sb0_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx3sb0_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx3sb0_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx3sc_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx3sc_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx3sc_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx3sc_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx3sc_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx3sc_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx4sb0_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx4sb0_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx4sb0_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx4sb0_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx4sb0_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx4sb0_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx4sc_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx4sc_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx4sc_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx4sc_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx4sc_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx4sc_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx5sb0_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx5sb0_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx5sb0_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx5sb0_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx5sb0_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx5sb0_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx5sc_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx5sc_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx5sc_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx5sc_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx5sc_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\mx5sc_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1na2x_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1na2x_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1na2x_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1na2x_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1na2x_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1na2x_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1no2x_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1no2x_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1no2x_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1no2x_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1no2x_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1no2x_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1xr2x_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1xr2x_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1xr2x_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1xr2x_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1xr2x_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1xr2x_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\n1_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na2p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na2p_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na2p_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na2p_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na2p_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na2p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na2x_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na2x_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na2x_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na2x_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na2x_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na2x_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na2_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na2_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na2_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na2_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na2_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na2_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na3p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na3p_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na3p_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na3p_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na3p_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na3p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na3_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na3_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na3_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na3_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na3_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\na3_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\ndrvp_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\ndrvp_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\ndrvp_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\ndrvp_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\ndrvp_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\ndrvp_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\ndrv_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\ndrv_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\ndrv_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\ndrv_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\ndrv_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\ndrv_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nmx2sb0_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nmx2sb0_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nmx2sb0_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nmx2sb0_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nmx2sb0_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nmx2sb0_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nmx2sc_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nmx2sc_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nmx2sc_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nmx2sc_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nmx2sc_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nmx2sc_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no2p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no2p_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no2p_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no2p_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no2p_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no2p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no2x_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no2x_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no2x_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no2x_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no2x_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no2x_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no2_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no2_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no2_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no2_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no2_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no2_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no3p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no3p_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no3p_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no3p_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no3p_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no3p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no3_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no3_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no3_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no3_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no3_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\no3_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\np1_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\np1_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\np1_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\np1_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\np1_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\np1_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nt1_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nt1_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nt1_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nt1_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nt1_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nt1_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nxr2x_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nxr2x_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nxr2x_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nxr2x_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nxr2x_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nxr2x_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nxr2_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nxr2_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nxr2_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nxr2_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nxr2_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nxr2_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz1t0w0p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz1t0w0p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz1t0w2p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz1t0w2p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz2l2w0p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz2l2w0p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz2t0w0p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz2t0w0p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz2t0w2p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz2t0w2p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz2t2w0p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz2t2w0p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz3t0w0p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz3t0w0p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz3t0w2p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz3t0w2p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz4l0w0p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz4l0w0p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz4l0w1p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz4l0w1p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz4l0w2p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz4l0w2p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz4l0w3p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz4l0w3p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz4t0w0p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz4t0w0p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz4t0w2p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\nz4t0w2p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o2p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o2p_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o2p_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o2p_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o2p_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o2p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o2_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o2_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o2_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o2_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o2_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o2_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o3p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o3p_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o3p_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o3p_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o3p_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o3p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o3_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o3_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o3_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o3_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o3_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\o3_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\one_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\one_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\one_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\one_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\one_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\one_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffb2_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffb2_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffb2_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffb2_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffb2_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffb2_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffb6_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffb6_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffb6_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffb6_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffb6_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffb6_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffba_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffba_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffba_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffba_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffba_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffba_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffbe_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffbe_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffbe_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffbe_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffbe_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffbe_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffub6_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pdffub6_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsa1_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsa1_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsa1_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsa1_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsa1_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsa1_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsa9_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsa9_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsa9_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsa9_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsa9_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsa9_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsh5_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsh5_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsh5_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsh5_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsh5_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsh5_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmshd_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmshd_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmshd_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmshd_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmshd_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmshd_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsi5_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsi5_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsi5_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsi5_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsi5_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsi5_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsid_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsid_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsid_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsid_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsid_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsid_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsj5_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsj5_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsj5_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsj5_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsj5_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsj5_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsjd_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsjd_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsjd_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsjd_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsjd_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsjd_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsp5_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsp5_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsp5_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsp5_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsp5_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsp5_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmspd_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmspd_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmspd_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmspd_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmspd_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmspd_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsq5_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsq5_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsq5_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsq5_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsq5_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsq5_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsqd_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsqd_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsqd_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsqd_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsqd_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\pmsqd_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\t1_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\t1_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\t1_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\t1_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\t1_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\t1_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\xr2_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\xr2_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z1t0w1p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z1t0w1p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z1t0w3p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z1t0w3p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z2l1w0p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z2l1w0p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z2l1w2p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z2l1w2p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z2t0w1p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z2t0w1p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z2t0w3p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z2t0w3p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z2t1w0p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z2t1w0p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z2t3w0p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z2t3w0p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z3t0w1p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z3t0w1p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z3t0w3p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z3t0w3p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z4t0w0p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z4t0w0p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z4t0w1p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z4t0w1p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z4t0w3p_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\z4t0w3p_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\zero_fp.ap"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\zero_fp.cp"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\zero_fp.hns"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\zero_fp.nle"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\zero_fp.sc"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\fplib\zero_fp.vbe"; Destdir: "{app}\alliance\share\cells\fplib"
Source: "alliance\share\cells\grog\grbl4_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grbl4_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmbob_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmbob_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmbs_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmbs_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmbt_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmbt_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmfeed_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmfeed_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmfill_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmfill_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmli_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmli_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmmot_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmmot_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmmt_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmmt_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmmx_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmmx_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmobh_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmobh_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmob_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmob_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmoebh_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmoebh_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmoth_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmoth_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrbom_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrbom_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrck_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrck_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrick_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrick_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrl_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrl_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrst_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrst_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrs_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrs_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrw0_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrw0_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrw1_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrw1_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrw2_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrw2_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrw3_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrw3_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrwb_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrwb_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrx0_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrx0_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrx1_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrx1_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrx2_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrx2_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrx3_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmrx3_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmx4_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grmx4_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grnbom_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grnbom_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grnbs_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grnbs_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grnmht_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grnmht_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grnrste_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grnrste_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grog.db"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grp4_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grp4_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpbom_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpbom_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpbs_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpbs_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpfeedh_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpfeedh_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpfeed_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpfeed_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpfill_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpfill_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpf_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpf_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpick_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpick_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpli_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpli_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpmht_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpmht_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpmt_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpmt_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpobhc_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpobhc_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpobhs_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpobhs_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpobhtc_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpobhtc_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpob_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpob_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grprste_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grprste_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grprst_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grprst_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grprs_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grprs_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grprw0_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grprw0_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grprw1_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grprw1_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grprw2_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grprw2_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grprw3_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grprw3_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grprx0_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grprx0_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grprx1_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grprx1_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpubht_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpubht_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpubobh_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpubobh_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpubob_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpubob_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpubt_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grpubt_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrbob_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrbob_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrbs1_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrbs1_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrbs2_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrbs2_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrbs3_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrbs3_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrbt_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrbt_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrfeed_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrfeed_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrfill_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrfill_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrli_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrli_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrmo_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrmo_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrmt_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrmt_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrmx_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrmx_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrobh_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrobh_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrob_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grrob_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grroebh_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grroebh_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grroth_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grroth_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grubom_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grubom_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grufill_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grufill_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grumf_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grumf_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grumx2et_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grumx2et_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grumx2e_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grumx2e_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grumx2ot_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grumx2ot_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grumx2o_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grumx2o_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobeht_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobeht_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobeh_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobeh_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobet_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobet_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobe_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobe_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobfe_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobfe_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobfh_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobfh_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobfo_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobfo_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobf_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobf_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruoboht_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruoboht_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruoboh_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruoboh_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobot_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobot_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobo_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruobo_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruoebh_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruoebh_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grurx1_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grurx1_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grurx2_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\grurx2_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruwi_c.ap"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\grog\gruwi_c.cp"; Destdir: "{app}\alliance\share\cells\grog"
Source: "alliance\share\cells\padlib\CATAL"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\padreal.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\padreal.cif"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\padsymb.db"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\palck_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\paliotw_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\paliot_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pali_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\palotw_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\palot_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\palow_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\palo_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\palvddeck_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\palvdde_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\palvddick_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\palvddi_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\palvsseck_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\palvsse_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\palvssick_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\palvssi_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pck_sp.al"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pck_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pck_sp.vbe"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\piotw_sp.al"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\piotw_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\piotw_sp.vbe"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\piot_sp.al"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\piot_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\piot_sp.vbe"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pi_sp.al"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pi_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pi_sp.vbe"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\potw_sp.al"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\potw_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\potw_sp.vbe"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pot_sp.al"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pot_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pot_sp.vbe"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pow_sp.al"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pow_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pow_sp.vbe"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\po_sp.al"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\po_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\po_sp.vbe"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvddeck_sp.al"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvddeck_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvddeck_sp.vbe"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvdde_sp.al"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvdde_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvdde_sp.vbe"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvddick_sp.al"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvddick_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvddick_sp.vbe"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvddi_sp.al"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvddi_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvddi_sp.vbe"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvsseck_sp.al"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvsseck_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvsseck_sp.vbe"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvsse_sp.al"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvsse_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvsse_sp.vbe"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvssick_sp.al"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvssick_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvssick_sp.vbe"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvssi_sp.al"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvssi_sp.ap"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\padlib\pvssi_sp.vbe"; Destdir: "{app}\alliance\share\cells\padlib"
Source: "alliance\share\cells\rage\CATAL"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtali1_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtali2_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtbadr0_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtbadr1_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtbadr2_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtbadr3_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtbadr4_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtbadr5_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtbmxe0_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtbmxe1_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtbmxe2_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtbmxl0_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtbmxl1_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtbmxl2y_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtbmxl2_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtbmxr0_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtbmxr1_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtbmxr2y_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtbmxr2_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtbmxr3y_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtbmxr3_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtcmb_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtcmp_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtcms2.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtcms3.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtcms_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtcmw2.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtcmw_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtdcd6_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtdcd7_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtdcd8_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtdcg6_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtdcg7_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtdcg8_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtedg0_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtedg1_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtedg2_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtedg3_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtext3_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtext4_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtext5_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtext6_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtinv2_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtinv3_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtinv_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtio0_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtio2_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtio3_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtio4_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtio_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtmx0_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtmxed2_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtmxed3_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtmxed4_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtmxeg2_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtmxeg3_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtmxeg4_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtmxi_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtmxm_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtpcg_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtpdc0_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtpdc1_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtpdc2_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtpdc3_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtpdcl_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtpre_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtram2_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dtram_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dttr0_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dttr1_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\rage\dttr2_c.ap"; Destdir: "{app}\alliance\share\cells\rage"
Source: "alliance\share\cells\README.cells"; Destdir: "{app}\alliance\share\cells"
Source: "alliance\share\cells\rfg\CATAL"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfahb2_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfahb4_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfal2_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfal4_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfalckmod_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfalck_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfal_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfaw16n_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfaw16_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfaw8n_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfaw8_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfbdo_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfblomod_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfblo_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfbslmod_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfbsl_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfbudo1b_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfbudo2b_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfbul1b_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfbul2b_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfbus1b_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfchr_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfchw16_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfchw8_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfcna1_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfcna2b_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfcna2_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfcna3d_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfcna3s_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfcna4d_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfcna4s_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfcnard_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfcnars_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfcnrw1_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfcnrw2_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfcnrw3_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfde1bf_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfde1bsf_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfde1bs_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfde1b_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfde2bf_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfde2bsf_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfde2bs_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfde2b_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfdi16n_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfdi16_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfdi8n_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfdi8_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfdi_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfdo1b_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfdo2b_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfl1bh_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfl1bl_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfl1b_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfl2bh_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfl2bl_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfl2b_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rflo1b_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rflo2b_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rfg\rfspe_c.ap"; Destdir: "{app}\alliance\share\cells\rfg"
Source: "alliance\share\cells\rsa\CATAL"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gac1y_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gaca1_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gaca2_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gaca3_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gaci0_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gaci2_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gaci4_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gaci8_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gacid_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gacin0_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gacin2_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gacin4_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gacin8_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gacind_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gacinp_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gacip_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gacoc_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gacon_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gaco_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gacsaf_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gacsay_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gacsa_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gae03_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gae0_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gaec03c_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gaec03_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gaec0c_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gaec0_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gaen03_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gaen0_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gai0y_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gai0_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gai1_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gapg0_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gapg2_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gapg4_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gapg8_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gapga4_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gapga8_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gapgad_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gapgap_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gapgm4_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gapgm8_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gapgmd_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gapgn0_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gapgn2_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gapgn4_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gapgn8_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gapgnd_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gas0c_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gas0f_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gas0y_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gas0_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gasub_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gasxr2b_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gaxr2b_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\gaxr2_c.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\rsa\ref_via.ap"; Destdir: "{app}\alliance\share\cells\rsa"
Source: "alliance\share\cells\sc2sxlib\a2p_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\a2_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\a3p_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\a3_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\a4p_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\a4_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\annup_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\b1_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\cmx2_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\cry_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\d1_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\ms2dp2_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\ms2dp4_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\msdp2_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\msdp4_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\mx2p_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\mx2_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\mx3_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\mx4_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\n1_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\na2p_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\na2_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\na3p_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\na3_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\na4_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\nao3_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\nao4_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\ndrvp_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\ndrv_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\nmx2_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\no2_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\no3_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\noa3_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\noa4_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\nop2_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\nop3_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\noue4_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\np1_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\nxr2_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\o2_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\o3_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\one_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\op2_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\op3_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\p1_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\sum_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\tie_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\tsn_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\tsp_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\ts_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\xr2_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\zbli_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sc2sxlib\zero_y.vst"; Destdir: "{app}\alliance\share\cells\sc2sxlib"
Source: "alliance\share\cells\sclib\000000002.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000003.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000004.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000005.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000006.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000007.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000008.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000009.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000010.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000011.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000012.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000013.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000014.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000015.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000016.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000017.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000018.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000019.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000020.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000021.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000022.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000023.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000024.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000025.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000026.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000027.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000028.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000029.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000030.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000031.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000032.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000033.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000034.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000035.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000036.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000037.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000038.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000039.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000040.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000041.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000042.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000043.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000044.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000045.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000046.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000047.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000048.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000049.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000050.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000051.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000052.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000053.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\000000054.dat"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a2p_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a2p_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a2p_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a2p_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a2p_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a2p_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a2_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a2_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a2_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a2_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a2_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a2_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a3p_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a3p_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a3p_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a3p_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a3p_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a3p_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a3_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a3_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a3_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a3_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a3_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a3_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a4p_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a4p_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a4p_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a4p_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a4p_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a4p_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a4_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a4_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a4_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a4_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a4_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\a4_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\annup_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\annup_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\annup_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\annup_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\annup_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\annup_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\b1_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\b1_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\b1_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\b1_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\b1_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\b1_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\CATAL"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\cctlist"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\CIRCUIT.IDX"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\cmx2_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\cmx2_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\cmx2_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\cmx2_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\cmx2_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\cmx2_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\cry_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\cry_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\cry_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\cry_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\cry_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\cry_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\d1_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\d1_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\d1_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\d1_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\d1_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\d1_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ms2dp2_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ms2dp2_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ms2dp2_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ms2dp2_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ms2dp2_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ms2dp2_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ms2dp4_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ms2dp4_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ms2dp4_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ms2dp4_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ms2dp4_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ms2dp4_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\msdp2_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\msdp2_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\msdp2_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\msdp2_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\msdp2_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\msdp2_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\msdp4_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\msdp4_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\msdp4_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\msdp4_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\msdp4_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\msdp4_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx2p_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx2p_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx2p_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx2p_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx2p_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx2p_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx2_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx2_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx2_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx2_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx2_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx2_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx3_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx3_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx3_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx3_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx3_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx3_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx4_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx4_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx4_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx4_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx4_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\mx4_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\n1_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\n1_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\n1_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\n1_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\n1_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\n1_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na2p_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na2p_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na2p_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na2p_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na2p_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na2p_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na2_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na2_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na2_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na2_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na2_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na2_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na3p_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na3p_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na3p_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na3p_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na3p_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na3p_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na3_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na3_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na3_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na3_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na3_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na3_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na4_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na4_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na4_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na4_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na4_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\na4_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nao3_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nao3_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nao3_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nao3_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nao3_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nao3_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nao4_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nao4_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nao4_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nao4_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nao4_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nao4_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ndrvp_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ndrvp_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ndrvp_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ndrvp_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ndrvp_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ndrvp_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ndrv_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ndrv_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ndrv_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ndrv_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ndrv_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ndrv_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nmx2_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nmx2_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nmx2_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nmx2_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nmx2_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nmx2_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\no2_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\no2_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\no2_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\no2_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\no2_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\no2_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\no3_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\no3_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\no3_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\no3_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\no3_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\no3_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\noa3_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\noa3_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\noa3_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\noa3_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\noa3_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\noa3_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\noa4_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\noa4_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\noa4_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\noa4_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\noa4_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\noa4_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nop2_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nop2_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nop2_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nop2_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nop2_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nop2_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nop3_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nop3_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nop3_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nop3_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nop3_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nop3_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\noue4_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\noue4_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\noue4_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\noue4_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\noue4_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\noue4_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\np1_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\np1_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\np1_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\np1_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\np1_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\np1_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nxr2_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nxr2_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nxr2_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nxr2_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nxr2_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\nxr2_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\o2_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\o2_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\o2_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\o2_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\o2_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\o2_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\o3_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\o3_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\o3_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\o3_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\o3_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\o3_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\one_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\one_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\one_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\one_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\one_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\one_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\op2_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\op2_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\op2_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\op2_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\op2_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\op2_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\op3_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\op3_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\op3_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\op3_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\op3_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\op3_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\p1_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\p1_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\p1_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\p1_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\p1_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\p1_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\sclib.db"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\sum_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\sum_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\sum_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\sum_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\sum_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\sum_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\tie_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\tie_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\tie_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\tie_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\tie_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\tie_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\tsn_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\tsn_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\tsn_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\tsn_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\tsn_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\tsn_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\tsp_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\tsp_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\tsp_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\tsp_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\tsp_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\tsp_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ts_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ts_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ts_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ts_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ts_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\ts_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\vlsi.atr"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\vlsi.boo"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\vlsi.idx"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\xr2_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\xr2_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\xr2_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\xr2_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\xr2_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\xr2_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\zbli_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\zbli_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\zbli_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\zbli_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\zbli_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\zbli_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\zero_y.al"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\zero_y.ap"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\zero_y.cp"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\zero_y.hns"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\zero_y.sc"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sclib\zero_y.vbe"; Destdir: "{app}\alliance\share\cells\sclib"
Source: "alliance\share\cells\sxlib\000000002.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000003.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000004.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000005.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000006.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000007.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000008.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000009.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000010.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000011.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000012.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000013.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000014.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000015.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000016.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000017.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000018.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000019.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000020.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000021.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000022.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000023.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000024.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000025.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000026.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000027.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000028.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000029.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000030.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000031.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000032.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000033.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000034.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000035.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000036.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000037.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000038.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000039.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000040.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000041.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000042.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000043.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000044.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000045.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000046.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000047.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000048.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000049.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000050.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000051.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000052.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000053.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000054.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000055.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000056.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000057.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000058.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000059.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000060.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000061.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000062.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000063.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000064.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000065.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000066.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000067.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000068.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000069.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000070.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000071.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000072.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000073.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000074.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000075.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000076.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000077.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000078.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000079.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000080.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000081.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000082.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000083.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000084.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000085.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000086.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000087.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000088.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000089.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000090.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000091.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000092.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000093.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000094.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\000000095.dat"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\a2_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\a2_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\a2_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\a2_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\a2_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\a2_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\a3_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\a3_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\a3_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\a3_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\a3_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\a3_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\a4_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\a4_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\a4_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\a4_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\a4_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\a4_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\an12_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\an12_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\an12_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\an12_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\an12_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\an12_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\ao22_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\ao22_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\ao22_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\ao22_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\ao22_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\ao22_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\ao2o22_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\ao2o22_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\ao2o22_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\ao2o22_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\ao2o22_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\ao2o22_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\buf_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\buf_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\buf_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\buf_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\buf_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\buf_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\buf_x8.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\buf_x8.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\buf_x8.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\CATAL"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\CIRCUIT.IDX"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\fulladder_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\fulladder_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\fulladder_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\fulladder_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\fulladder_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\fulladder_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\halfadder_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\halfadder_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\halfadder_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\halfadder_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\halfadder_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\halfadder_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\inv_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\inv_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\inv_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\inv_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\inv_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\inv_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\inv_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\inv_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\inv_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\inv_x8.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\inv_x8.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\inv_x8.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\mx2_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\mx2_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\mx2_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\mx2_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\mx2_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\mx2_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\mx3_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\mx3_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\mx3_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\mx3_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\mx3_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\mx3_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\na2_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\na2_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\na2_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\na2_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\na2_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\na2_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\na3_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\na3_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\na3_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\na3_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\na3_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\na3_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\na4_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\na4_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\na4_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\na4_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\na4_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\na4_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nao22_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nao22_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nao22_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nao22_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nao22_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nao22_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nao2o22_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nao2o22_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nao2o22_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nao2o22_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nao2o22_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nao2o22_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nmx2_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nmx2_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nmx2_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nmx2_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nmx2_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nmx2_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nmx3_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nmx3_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nmx3_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nmx3_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nmx3_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nmx3_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\no2_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\no2_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\no2_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\no2_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\no2_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\no2_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\no3_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\no3_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\no3_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\no3_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\no3_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\no3_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\no4_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\no4_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\no4_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\no4_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\no4_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\no4_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa22_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa22_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa22_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa22_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa22_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa22_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2a22_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2a22_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2a22_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2a22_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2a22_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2a22_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2a2a23_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2a2a23_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2a2a23_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2a2a23_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2a2a23_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2a2a23_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2a2a2a24_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2a2a2a24_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2a2a2a24_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2a2a2a24_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2a2a2a24_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2a2a2a24_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2ao222_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2ao222_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2ao222_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2ao222_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2ao222_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa2ao222_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa3ao322_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa3ao322_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa3ao322_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa3ao322_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa3ao322_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\noa3ao322_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nts_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nts_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nts_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nts_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nts_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nts_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nxr2_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nxr2_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nxr2_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nxr2_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nxr2_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\nxr2_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\o2_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\o2_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\o2_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\o2_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\o2_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\o2_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\o3_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\o3_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\o3_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\o3_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\o3_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\o3_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\o4_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\o4_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\o4_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\o4_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\o4_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\o4_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa22_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa22_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa22_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa22_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa22_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa22_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2a22_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2a22_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2a22_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2a22_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2a22_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2a22_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2a2a23_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2a2a23_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2a2a23_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2a2a23_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2a2a23_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2a2a23_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2a2a2a24_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2a2a2a24_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2a2a2a24_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2a2a2a24_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2a2a2a24_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2a2a2a24_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2ao222_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2ao222_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2ao222_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2ao222_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2ao222_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa2ao222_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa3ao322_x2.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa3ao322_x2.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa3ao322_x2.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa3ao322_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa3ao322_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\oa3ao322_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\on12_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\on12_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\on12_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\on12_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\on12_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\on12_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\one_x0.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\one_x0.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\one_x0.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\rowend_x0.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\rowend_x0.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\rowend_x0.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\sff1_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\sff1_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\sff1_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\sff2_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\sff2_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\sff2_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\sff3_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\sff3_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\sff3_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\sxlib.cct"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\sxlib.db"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\sxlib.lib"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\sxlib.sdb"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\sxlib.slib"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\tie_x0.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\tie_x0.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\tie_x0.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\ts_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\ts_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\ts_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\ts_x8.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\ts_x8.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\ts_x8.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\xr2_x1.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\xr2_x1.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\xr2_x1.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\xr2_x4.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\xr2_x4.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\xr2_x4.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\zero_x0.al"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\zero_x0.ap"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\cells\sxlib\zero_x0.vbe"; Destdir: "{app}\alliance\share\cells\sxlib"
Source: "alliance\share\doc\overview\Makefile"; Destdir: "{app}\alliance\share\doc\overview"
Source: "alliance\share\doc\overview\na3dp.ps"; Destdir: "{app}\alliance\share\doc\overview"
Source: "alliance\share\doc\overview\na3y.ps"; Destdir: "{app}\alliance\share\doc\overview"
Source: "alliance\share\doc\overview\nmx2_dp.ps"; Destdir: "{app}\alliance\share\doc\overview"
Source: "alliance\share\doc\overview\nmx2_y.ps"; Destdir: "{app}\alliance\share\doc\overview"
Source: "alliance\share\doc\overview\overview.blg"; Destdir: "{app}\alliance\share\doc\overview"
Source: "alliance\share\doc\overview\overview.tex"; Destdir: "{app}\alliance\share\doc\overview"
Source: "alliance\share\doc\overview\thesis.bib"; Destdir: "{app}\alliance\share\doc\overview"
Source: "alliance\share\doc\overview\tools.eps"; Destdir: "{app}\alliance\share\doc\overview"
Source: "alliance\share\doc\overview\tools.fig"; Destdir: "{app}\alliance\share\doc\overview"
Source: "alliance\share\doc\overview.pdf"; Destdir: "{app}\alliance\share\doc"
Source: "alliance\share\doc\overview.ps"; Destdir: "{app}\alliance\share\doc"
Source: "alliance\share\doc\process_mapping.pdf"; Destdir: "{app}\alliance\share\doc"
Source: "alliance\share\doc\process_mapping.ps"; Destdir: "{app}\alliance\share\doc"
Source: "alliance\share\etc\alc_env.bat"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\alc_env.bat.in"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\alc_env.bat.orig"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\alc_env.csh"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\alc_env.csh.in"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\alc_env.sh"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\alc_env.sh.in"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\algue\alliance.gif"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\alliance.tk"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\asim.gif"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\asimut.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\bbr.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\bop.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\bsg.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\Dialogue.tcl"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\dpr.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\dreal.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\druc.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\fpgen.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\fpmap.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\genlib.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\genpat.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\genview.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\glop.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\graal.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\grog.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\lip6.gif"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\lvx.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\lynx.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\main.cfg"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\maine.cfg"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\proof.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\rage.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\rfg.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\ring.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\rsa.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\s2r.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\scmap.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\scr.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\Supervision_cmdunix.tcl"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\syf.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\tas.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\tclIndex"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\algue\yagle.env"; Destdir: "{app}\alliance\share\etc\algue"
Source: "alliance\share\etc\Alliance Console.lnk"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\Alliance Home Page.url"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\alliance.ico"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\alliance_os.mk.in"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\asga_7.dreal"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\asga_7.genview"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\asga_7.graal"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\asga_7.rds"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\cmos_10.rds"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\cmos_7.dreal"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\cmos_7.genview"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\cmos_7.graal"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\cmos_7.rds"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\cmos_7.rds.1999.09.30"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\cmos_8.rds"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\cmos_9.graal"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\cmos_9.rds"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\config.log"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\config.status"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\configure"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\configure.in"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\Cygwin.mk"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\Cygwin.mk.orig"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\libraries.mk"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\Linux.mk"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\prol035.elp"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\prol035.rds"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\prol05.elp"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\prol05.rds"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\prol10.elp"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\prol10_7.rds"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\prol10_8.rds"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\Solaris.mk"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\SunOS.mk"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\xfsm.par"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\xpat.par"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\etc\xsch.par"; Destdir: "{app}\alliance\share\etc"
Source: "alliance\share\man\man1\abl.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\abl101.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\alcbanner.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\alc_bug_report.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\alc_contents.mac"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\alc_origin.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\algue.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\ali.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\amg.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\asimut.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\aut101.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\bbr.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\bdd.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\bdd101.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\bgd.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\bop.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\bsg.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\buseg.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\c4map.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\dlx_asm.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\dpp.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\dpr.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\dreal.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\druc.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\etas.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\fpgen.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\fpmap.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\fsm101.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\genbs.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\genlib.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\genpat.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\genscan.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\genview.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\glop.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\graal.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\grog.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\k2f.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\l2p.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\librds.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\librfm.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\librpr.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\librtl.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\librut.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\librwi.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\log.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\lvx.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\lynx.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\mbk.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\mbk2ps.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\mbkcif.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\MBK_CATAL_NAME.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\MBK_CATA_LIB.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\MBK_FILTER_SFX.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\MBK_IN_FILTER.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\MBK_IN_LO.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\MBK_IN_PH.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\MBK_OUT_FILTER.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\MBK_OUT_LO.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\MBK_OUT_PH.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\MBK_SEPAR.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\MBK_VDD.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\MBK_VSS.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\MBK_WORK_LIB.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\pat2dwl.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\patest.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\proof.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\rage.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\rds.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\RDS_IN.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\RDS_OUT.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\RDS_TECHNO_NAME.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\rfg.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\ring.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\rsa.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\s2r.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\scmap.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\scr.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\syf.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\tas.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\vasy.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\xmbk.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man1\yagle.1"; Destdir: "{app}\alliance\share\man\man1"
Source: "alliance\share\man\man3\ablToBddCct.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\aboxmbkrds.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\ACTION.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addablhexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addablqexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addauth2elem.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addauthelem.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addbddassoc.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addbddcircuitabl.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addbddcircuitin.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addbddcircuitout.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addbddnode.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addbddnodeassoc.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addbddnodelist.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addbddvar.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addbddvarafter.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addbddvarbefore.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addbddvarfirst.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addbddvarlast.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addcapa.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addchain.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addHExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addht.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addhtitem.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addInputCct.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addListBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addlocon.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addlofig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addloins.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addlomodel.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addlosig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addlotrs.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addnum.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addOutputCct.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addphcon.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addphfig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addphins.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addphref.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addphseg.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addphvia.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addptype.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addQExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addrdsfig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addrdsfigrec.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addrdsins.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addrdsinsrec.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addrdsrecwindow.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\addTH.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\AFFECT.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\alliancebanner.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\allocrdsfig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\allocrdsins.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\allocrdsrec.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\allocrdsrecwin.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\allocrdswin.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\allocrdswindow.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\allocrdswinrec.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\anyExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\append.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\applyBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\applybddnode.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\applybddnodeite.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\applybddnodelist.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\applybddnodenot.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\applybddnodeterm.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\applyBinBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\applyrdssym.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\apr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\arp.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\ARRAY.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\autallocblock.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\autallocheap.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\autfreeblock.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\autfreeheap.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\auth2elem.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\auth2table.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\authelem.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\authtable.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\autresizeblock.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\bddToAblCct.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beaux.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\bebus.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\bebux.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\befig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\begen.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_addbeaux.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_addbebus.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_addbebux.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_addbefig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_addbegen.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_addbemsg.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_addbeout.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_addbepor.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_addbereg.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_addberin.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_addbiabl.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_addbinod.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_debug.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_delbeaux.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_delbebus.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_delbebux.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_delbefig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_delbegen.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_delbemsg.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_delbeout.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_delbepor.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_delbereg.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_delberin.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_delbiabl.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_delbinod.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_depend.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_error.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_frebeaux.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_frebebus.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_frebebux.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_frebefig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_frebegen.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_frebemsg.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_frebeout.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_frebepor.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_frebereg.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_freberin.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_frebiabl.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_frebinod.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_getgenva.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_makbdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_makgex.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_message.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_rmvbeaux.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_rmvbebus.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_rmvbebux.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_rmvbefig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_rmvbegen.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_rmvbemsg.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_rmvbeout.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_rmvbepor.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_rmvbereg.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beh_rmvberin.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\bemsg.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\beout.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\bepor.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\bereg.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\berin.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\biabl.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\bigvia.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\binod.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\binode.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\buildrdswindow.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\BUS.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\chain.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\changeOperExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\charToExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\charToOper.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\checkloconorder.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\clearbddsystemref.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\clearbddsystemrefext.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\clearbddsystemrefint.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\cofactorbddnode.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\comment.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\composeBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\composebddnode.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\composeCct.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\concatname.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\conmbkrds.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\constraintBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\constraintCct.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\conv.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\convcmp.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\convertbddcircuitabl.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\convertbddcircuitsumabl.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\convertbddindexabl.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\convertbddmuxabl.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\convertbddnodeabl.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\convertbddnodesumabl.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\copyExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\COPY_UP_ALL_CON.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\COPY_UP_ALL_REF.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\COPY_UP_CON.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\COPY_UP_CON_FACE.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\COPY_UP_REF.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\COPY_UP_SEG.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\cpOrderCct.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\createablatom.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\createablbinexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\createablnotexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\createabloper.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\createablunaryexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\createablxorbinexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\createAtom.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\createauth2table.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\createauthtable.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\createbddcircuit.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\createbddsystem.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\createBinExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\createExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\createNodeTermBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\createTH.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\decbddrefext.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\decbddrefint.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DECLAR.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\defab.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DEF_AB.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DEF_GENPAT.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DEF_LOFIG.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DEF_PHFIG.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DEF_PHINS.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DEF_PHSC.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delablexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delablexprnum.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delauth2elem.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delauthelem.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delbddassoc.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delbddcircuitout.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delbddnode.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delbddnodeassoc.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delbddnodelist.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delchain.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\deleteNumExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\deleteTH.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delht.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delhtitem.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\dellocon.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\dellofig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delloins.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\dellosig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\dellotrs.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delnum.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delphcon.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delphfig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delphins.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delphref.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delphseg.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delphvia.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delptype.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delrdsfig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delrdsfigrec.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delrdsins.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delrdsinsrec.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\delrdsrecwindow.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\destroyauth2table.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\destroyauthtable.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\destroyBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\destroybddassoc.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\destroybddcircuit.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\destroybddsystem.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\destroyCct.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\destroyrdswindow.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\destroyTH.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\devablxorexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\devdupablxorexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\devXor2Expr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\devXorExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\displayBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\displayCct.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\displayExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\displayInfExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\displayTH.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\downstr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_ADD2F.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_ADSB2.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_ADSB2F.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_AND2.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_AND3.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_BUFF.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_BUSE.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_CONST.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_DEFLOFIG.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_IMPORT.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_INV.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_LOCON.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_MULT.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_MULTP.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_MUX2CS.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_MUX3CD.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_MUX3CS.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_MUX4CS.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_MUX5CS.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_NAND2.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_NAND2MASK.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_NAND3.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_NBUSE.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_NMUX2CS.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_NOR2.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_NOR2MASK.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_NOR3.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_NUL.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_OR2.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_OR3.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_PDFF.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_PDFFQ.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_PDFFR.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_PDFFRT.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_PDFFT.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_PDFFTQ.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_RFG1C0.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_RFG1CC.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_RFG2C0.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_RFG2CC.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_SAVLOFIG.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_SHIFT.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_TRACE.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_XNOR2.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_XNOR2MASK.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\DP_XOR2.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\dupablexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\ELM.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\equalExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\equalVarExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\everyExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\existbddnodeassocoff.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\existbddnodeassocon.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\exprToChar.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\figmbkrds.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\filepath.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\flatablexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\flatArityExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\flatPolarityExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\flattenlofig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\flattenphfig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\FLATTEN_ALL_LOINS.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\FLATTEN_ALL_PHINS.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\FLATTEN_LOFIG.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\FLATTEN_PHFIG.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\freeablexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\freechain.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\freeExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\freelomodel.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\freenum.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\freeptype.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\freerdsfig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\freerdsins.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\freerdsrec.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\funbeaux.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\funbebus.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\funbebux.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\funbefig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\funbegen.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\funbemsg.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\funbeout.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\funbepor.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\funbereg.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\funberin.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\funbiabl.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\funbinod.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\funpacom.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\funpaevt.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\funpagrp.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\funpaini.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\funpaiol.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\funpapat.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\funpaseq.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\garbagebddsystem.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\gcNodeBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\gcNodeCct.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getablexprdepth.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getablexprlength.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getablexprmax.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getablexprmin.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getablexprnum.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getablexprnumatom.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getablexprnumbinoper.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getablexprnumocc.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getablexprsupport.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getbddnodenum.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getbddnodesize.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getbddnodesupport.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getbddvarbyindex.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getbddvarindex.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getbddvarnode.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getbddvarnodebyindex.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\GETCPAT.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\gethtitem.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getlocon.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getlofig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getloins.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getlomodel.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getlosig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getphcon.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getphfig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getphins.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getphref.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getptype.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getrdsfig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getrdsmodellist.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\getsigname.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\GET_CON_X.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\GET_CON_Y.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\GET_INS_X.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\GET_INS_Y.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\GET_REF_X.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\GET_REF_Y.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\givelosig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\grog.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\guessextdir.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\HEIGHT.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\identExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\implybddnode.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\incatalog.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\incatalogdelete.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\incatalogfeed.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\incataloggds.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\incbddrefext.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\incbddrefint.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\INIT.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\initializeBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\initializeCct.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\insconmbkrds.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\insmbkrds.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\insrefmbkrds.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\inssegmbkrds.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\instanceface.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\instr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\insviambkrds.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\intersectbddnode.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\isablbinaryoper.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\isablequalexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\isablnameinexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\isabloperinexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\isablsimilarexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\isablunaryoper.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\isbddvarinsupport.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\isvdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\isvss.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\LABEL.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\lengthExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\libpat.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\loadlofig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\loadphfig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\loadrdsfig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\loadrdsparam.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\LOAD_LOFIG.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\LOAD_PHFIG.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\LOCON.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\lofig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\lofigchain.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\log.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\LOINS.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\LOINSE.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\LOSIG.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\LOSIGMERGE.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\LOTRS.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\mapablanyexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\mapableveryexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\mapablexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\mapabloperexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\mapCarExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\mapExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\markAllBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\markBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\markbddnode.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\maxExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\mbk.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\mbkalloc.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\mbkenv.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\mbkfopen.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\mbkfree.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\mbkps.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\mbkrealloc.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\mbkunlink.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\minExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\mlodebug.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\modelmbkrds.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\mphdebug.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\namealloc.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\namefind.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\nameindex.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\naturalstrcmp.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\normExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\notBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\notExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\num.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\numberAtomExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\numberNodeAllBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\numberNodeBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\numberNodeCct.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\numberOccExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\numberOperBinExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\OpenVerticalChannel.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\operToChar.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\OUTLINE.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\pacom.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\paevt.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\pagrp.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\paini.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\paiol.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\papat.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\paseq.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\pat.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\pat_addpacom.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\pat_addpaevt.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\pat_addpagrp.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\pat_addpaini.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\pat_addpaiol.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\pat_addpapat.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\pat_addpaseq.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\pat_crtpaiol.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\pat_debug.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\pat_frepacom.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\pat_frepaevt.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\pat_frepaini.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\pat_frepaiol.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\pat_frepapat.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\pat_lodpaseq.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\pat_savpaseq.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\PHCON.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\phfig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\phins.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\PHREF.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\PHSEG.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\PHVIA.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\PLACE.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\PLACE_BOTTOM.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\PLACE_CON_REF.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\PLACE_LEFT.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\PLACE_ON.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\PLACE_RIGHT.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\PLACE_SEG_REF.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\PLACE_TOP.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\PLACE_VIA_REF.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\PMExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\polarablexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\polardupablexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\port.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\process.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\profAOExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\profExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\proofCct.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\ptype.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\rdsalloc.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\rdsenv.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\rdsfree.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\refmbkrds.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\register.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\relprodbddnodeassoc.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\reorderbddsystemdynamic.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\reorderbddsystemsimple.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\reorderbddsystemtop.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\reorderbddsystemwindow.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\resetauth2table.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\resetauthtable.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\resetBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\resetbddcircuit.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\resetbddsystem.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\resetCct.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\restorealldir.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\restoredirvbe.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\restrictbddnode.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\reverse.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\REVERSE_PHCON.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\RFG2CC.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\rflattenlofig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\rflattenphfig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\roundrdsrec.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\rsa.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\satisfybddnode.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\SAVE.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\savelofig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\savephfig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\saverdsfig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\SAVE_LOFIG.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\SAVE_PHFIG.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\SAVE_PHSC.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\SAV_GENPAT.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\SC_BOTTOM.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\SC_LEFT.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\SC_PLACE.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\SC_RIGHT.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\SC_TOP.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\searchauth2elem.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\searchauthelem.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\searchbddcircuitin.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\searchbddcircuitout.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\searchExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\searchInputCct.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\searchNumExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\searchOperExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\searchOutputCct.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\searchrdsfig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\searchTH.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\segmbkrds.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\setbddrefext.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\sethtitem.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\SETTUNIT.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\signal.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\simpablexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\simpbddnodedcoff.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\simpbddnodedcon.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\simpdupablexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\simplif10Expr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\simplifDcOneBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\simplifDcZeroBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\simplifNotExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\sortautarray.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\sortExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\sortlocon.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\sortlosig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\substablexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\substbddnodeassoc.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\substdupablexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\substExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\substPhyExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\supportChain_listBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\supportChain_listExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\supportPtype_listExpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\swapbddvar.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\SymbolicChannelRouter.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\testbddcircuit.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\THRU_CON_H.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\THRU_CON_V.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\THRU_H.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\THRU_V.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\unflatablexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\unflattenlofig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\UNFLATTEN_LOFIG.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\unmarkbddnode.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\unsetbddrefext.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\upstr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\upVarBdd.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\upVarCct.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\vhdlablname.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\vhdlablvector.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viambkrds.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewablexpr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewablexprfile.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewablexprstr.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewbddcircuit.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewbddnode.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewbddsystem.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewbddsysteminfo.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewht.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewlo.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewlofig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewlofigcon.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewloins.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewloinscon.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewlosig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewlotrs.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewph.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewphcon.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewphfig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewphins.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewphref.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewphseg.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewphvia.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewrdsfig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewrdsins.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewrdsparam.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewrdsrec.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewrdswindow.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewrfmcon.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewrfmfig.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewrfmins.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewrfmrec.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewrfmref.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewrfmseg.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\viewrfmvia.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\WIDTH.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\WIRE1.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\WIRE2.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\WIRE3.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man3\xyflat.3"; Destdir: "{app}\alliance\share\man\man3"
Source: "alliance\share\man\man5\a2p_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\a2p_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\a2_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\a2_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\a3p_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\a3p_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\a3_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\a3_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\a4p_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\a4p_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\a4_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\a4_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\ai.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\al.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\annup_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\annup_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\ap.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\b1_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\b1_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\catal.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\cmx2_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\cry_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\cry_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\d1_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\dplib.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\dtv.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\fcl.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\fplib.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\fsm.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\htv.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\inf.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\l1n_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\l1x_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\l1_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\l2n_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\l2_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\l3r_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\l3s_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\l3_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\l4r_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\l4s_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\l4_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\l5r_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\l5s_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\l5_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\l6r_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\l6s_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\lax.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\ms2n_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\ms2n_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\ms2rx_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\ms2rx_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\ms2sx_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\ms2sx_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\ms2x_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\ms2x_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\ms2_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\ms2_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\msn_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\msn_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\msrx_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\msrx_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\mssx_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\mssx_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\msx_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\msx_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\ms_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\ms_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\mx2p_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\mx2p_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\mx2_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\mx2_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\mx3_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\mx3_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\mx4_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\n1_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\n1_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\na2p_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\na2p_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\na2_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\na2_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\na3p_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\na3p_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\na3_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\na3_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\na4_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\na4_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\nao3_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\nao3_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\nao4_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\nao4_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\ndrv_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\ndrv_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\neou4_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\nmx2_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\nmx2_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\no2_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\no2_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\no3_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\no3_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\noa3_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\noa3_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\noa4_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\noa4_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\nop2_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\nop2_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\nop3_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\nop3_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\noue4_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\noue4_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\np1_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\np1_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\nxr2_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\nxr2_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\o2_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\o2_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\o3_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\o3_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\one_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\one_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\op2_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\op2_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\op3_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\op3_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\p1_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\p1_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\pat.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\pck_sp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\piotw_sp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\piot_sp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\pi_sp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\potw_sp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\pot_sp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\pow_sp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\po_sp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\prol.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\pvddeck_sp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\pvdde_sp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\pvddick_sp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\pvddi_sp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\pvsseck_sp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\pvsse_sp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\pvssick_sp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\pvssi_sp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\sclib.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\spi.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\sum_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\sum_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\sxlib.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\tie_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\tpl.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\tsn_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\tsn_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\tsp_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\ts_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\ts_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\ttv.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\vasy.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\vbe.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\vhdl.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\vst.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\xr2_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\xr2_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\zbli_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\zero_dp.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\man5\zero_y.5"; Destdir: "{app}\alliance\share\man\man5"
Source: "alliance\share\man\README.man"; Destdir: "{app}\alliance\share\man"
Source: "alliance\share\man\whatis"; Destdir: "{app}\alliance\share\man"
Source: "alliance\share\man\windex"; Destdir: "{app}\alliance\share\man"
Source: "alliance\share\tutorials\addaccu\addaccu.c"; Destdir: "{app}\alliance\share\tutorials\addaccu"
Source: "alliance\share\tutorials\addaccu\addaccu.pat"; Destdir: "{app}\alliance\share\tutorials\addaccu"
Source: "alliance\share\tutorials\addaccu\addaccu.pdf"; Destdir: "{app}\alliance\share\tutorials\addaccu"
Source: "alliance\share\tutorials\addaccu\addaccu.ps"; Destdir: "{app}\alliance\share\tutorials\addaccu"
Source: "alliance\share\tutorials\addaccu\addaccu.rin"; Destdir: "{app}\alliance\share\tutorials\addaccu"
Source: "alliance\share\tutorials\addaccu\addaccu.vbe"; Destdir: "{app}\alliance\share\tutorials\addaccu"
Source: "alliance\share\tutorials\addaccu\addaccue.inf"; Destdir: "{app}\alliance\share\tutorials\addaccu"
Source: "alliance\share\tutorials\addaccu\core.c"; Destdir: "{app}\alliance\share\tutorials\addaccu"
Source: "alliance\share\tutorials\addaccu\genvect.c"; Destdir: "{app}\alliance\share\tutorials\addaccu"
Source: "alliance\share\tutorials\addaccu\Makefile"; Destdir: "{app}\alliance\share\tutorials\addaccu"
Source: "alliance\share\tutorials\addaccu\tex\addaccu.eps"; Destdir: "{app}\alliance\share\tutorials\addaccu\tex"
Source: "alliance\share\tutorials\addaccu\tex\addaccu.fig"; Destdir: "{app}\alliance\share\tutorials\addaccu\tex"
Source: "alliance\share\tutorials\addaccu\tex\addaccu.tex"; Destdir: "{app}\alliance\share\tutorials\addaccu\tex"
Source: "alliance\share\tutorials\addaccu\tex\hierarchy.eps"; Destdir: "{app}\alliance\share\tutorials\addaccu\tex"
Source: "alliance\share\tutorials\addaccu\tex\hierarchy.fig"; Destdir: "{app}\alliance\share\tutorials\addaccu\tex"
Source: "alliance\share\tutorials\addaccu\tex\Makefile"; Destdir: "{app}\alliance\share\tutorials\addaccu\tex"
Source: "alliance\share\tutorials\addaccu\vecteurs.pat"; Destdir: "{app}\alliance\share\tutorials\addaccu"
Source: "alliance\share\tutorials\amd2901\amd.vbe"; Destdir: "{app}\alliance\share\tutorials\amd2901"
Source: "alliance\share\tutorials\amd2901\AMD2901-doc.tgz"; Destdir: "{app}\alliance\share\tutorials\amd2901"
Source: "alliance\share\tutorials\amd2901\amd2901.pdf"; Destdir: "{app}\alliance\share\tutorials\amd2901"
Source: "alliance\share\tutorials\amd2901\amd2901.ps"; Destdir: "{app}\alliance\share\tutorials\amd2901"
Source: "alliance\share\tutorials\amd2901\chip.c"; Destdir: "{app}\alliance\share\tutorials\amd2901"
Source: "alliance\share\tutorials\amd2901\chip.inf"; Destdir: "{app}\alliance\share\tutorials\amd2901"
Source: "alliance\share\tutorials\amd2901\chip.rin"; Destdir: "{app}\alliance\share\tutorials\amd2901"
Source: "alliance\share\tutorials\amd2901\heart.scr"; Destdir: "{app}\alliance\share\tutorials\amd2901"
Source: "alliance\share\tutorials\amd2901\Makefile"; Destdir: "{app}\alliance\share\tutorials\amd2901"
Source: "alliance\share\tutorials\amd2901\pattern.pat"; Destdir: "{app}\alliance\share\tutorials\amd2901"
Source: "alliance\share\tutorials\amd2901\tex\amd2901.tex"; Destdir: "{app}\alliance\share\tutorials\amd2901\tex"
Source: "alliance\share\tutorials\amd2901\tex\Makefile"; Destdir: "{app}\alliance\share\tutorials\amd2901\tex"
Source: "alliance\share\tutorials\dlxm\add000.s"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\add000.u"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\CATAL"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\CATAL_CPU_BLOCKS"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\CATAL_CPU_CHIP"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\CATAL_CPU_GATES"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\dlxm.pdf"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\dlxm.ps"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\dlxm_chip.rin"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\dlxm_chip.vbe"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\dlxm_chip.vst"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\dlxm_core.c"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\dlxm_core.vst"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\dlxm_cpu.pat"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\dlxm_cpu.vst"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\dlxm_ctl.scr"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\dlxm_ctl.vst.h"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\dlxm_dec.vbe"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\dlxm_dpt.c"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\dlxm_dpt.dpr"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\dlxm_dpt.vbe"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\dlxm_scan.pat"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\dlxm_seq.enc"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\dlxm_seq.fsm"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\dlxm_sts.vbe"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\latex\dlxm.tex"; Destdir: "{app}\alliance\share\tutorials\dlxm\latex"
Source: "alliance\share\tutorials\dlxm\latex\Makefile"; Destdir: "{app}\alliance\share\tutorials\dlxm\latex"
Source: "alliance\share\tutorials\dlxm\Makefile"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\roms2.vbe"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\romu2.vbe"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\sr64_1a.vbe"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\sr64_32a.vst"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\sr64_8a.vst"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\dlxm\stock_asm\add000.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\add000.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\add001.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\add001.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\add002.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\add002.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\add003.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\add003.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\add004.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\add004.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\add005.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\add005.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\and000.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\and000.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\bne000.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\bne000.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc000.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc000.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc001.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc001.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc002.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc002.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc003.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc003.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc004.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc004.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc005.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc005.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc006.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc006.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc007.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc007.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc008.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc008.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc009.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc009.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc010.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\exc010.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\jal000.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\jal000.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\jal001.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\jal001.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\lb000.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\lb000.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\or000.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\or000.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\or001.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\or001.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\reg000.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\reg000.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\seq000.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\seq000.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\seq001.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\seq001.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\seq002.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\seq002.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\sge000.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\sge000.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\sle000.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\sle000.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\sne000.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\sne000.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\sne001.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\sne001.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\trp000.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\trp000.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\xor000.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\xor000.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\xor001.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\xor001.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\xor002.s"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\stock_asm\xor002.u"; Destdir: "{app}\alliance\share\tutorials\dlxm\stock_asm"
Source: "alliance\share\tutorials\dlxm\timer.vbe"; Destdir: "{app}\alliance\share\tutorials\dlxm"
Source: "alliance\share\tutorials\fitpath\adder_us.vbe"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\fitpath.pdf"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\fitpath.ps"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\hierarchy_dpt.c"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\hierarchy_dpt.dpr"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\hierarchy_dpt.inf"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\hierarchy_dpt.sh"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\make.LOG"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\Makefile"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\place_dpt.c"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\place_dpt.dpr"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\place_dpt.inf"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\place_dpt.sh"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\README"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\sample_dpt.c"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\sample_dpt.dpr"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\sample_dpt.inf"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\sample_dpt.pat"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\sample_dpt.sh"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\sample_dpt.vbe"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\sample_dpt.vbe.old"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\synthesis_dpt.c"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\synthesis_dpt.dpr"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\synthesis_dpt.inf"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\synthesis_dpt.sh"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\tex\fitpath.tex"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\gates.fig"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\hierarchy_dpt-1.fig"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\Makefile"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\sample_dpt-1.fig"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\sample_dpt-2.fig"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\sample_dpt-3.fig"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\sample_dpt-4.fig"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\sample_dpt-5.fig"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\sample_dpt-6.fig"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\trace-desb-1.ps"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\trace-dpr-1.ps"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\trace-druc-1.ps"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\trace-fpgen-1.ps"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\trace-logic-1.ps"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\trace-logic-2.ps"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\trace-lvx-1.ps"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\trace-lynx-1.ps"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\trace-lynx-2.ps"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\trace-proof-1.ps"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\tex\usercol_dpt-2.fig"; Destdir: "{app}\alliance\share\tutorials\fitpath\tex"
Source: "alliance\share\tutorials\fitpath\usercol_dpt.c"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\usercol_dpt.dpr"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\usercol_dpt.inf"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\fitpath\usercol_dpt.sh"; Destdir: "{app}\alliance\share\tutorials\fitpath"
Source: "alliance\share\tutorials\README.tutorials"; Destdir: "{app}\alliance\share\tutorials"
Source: "alliance\archi\Cygwin\cells"; Destdir: "{app}\alliance\archi\Cygwin"; Attribs: system
Source: "alliance\archi\Cygwin\doc"; Destdir: "{app}\alliance\archi\Cygwin"; Attribs: system
Source: "alliance\archi\Cygwin\etc"; Destdir: "{app}\alliance\archi\Cygwin"; Attribs: system
Source: "alliance\archi\Cygwin\man"; Destdir: "{app}\alliance\archi\Cygwin"; Attribs: system
Source: "alliance\archi\Cygwin\tutorials"; Destdir: "{app}\alliance\archi\Cygwin"; Attribs: system
